
;***   test irq 8 ***

        .386
        .Model FLAT, stdcall

        .data
        
oldint70    df 0
csalias     dw 0
dwScrnPos   dd 0
bMask       db 0
bStatus     db 0

        .code

IncScr  proc    uses ecx ebx
        mov     cl,8
        mov     ebx,cs:[dwScrnPos]
nextchar:
        inc     byte ptr [ebx]
        cmp     byte ptr [ebx],'9'
        jbe     done
        mov     byte ptr [ebx],'0'
        dec     ebx
        dec     ebx
        dec     cl
        jnz     nextchar
done:
        ret
IncScr  endp


myint70 proc

		push	eax
        mov		al,0Ch		;have to read RTC status 0C!
        out		70h,al
        xchg	ebx, ebx
        in		al,71h
		test	al,40h
        jz		skip

        push    ds
        mov     ds,cs:[csalias]
        call    IncScr
        pop     ds
skip:        
if 0
		pop		eax
        db 2eh
        jmp     fword ptr oldint70
else
        
        mov		al,20h
        out		0A0h,al
        out		020h,al
        pop		eax
        sti
        iretd
endif
        
myint70 endp

InitScr proc
        mov     eax,0B8000h
        add     eax,79*2
        mov     dwScrnPos,eax
        mov     cl,8
nextchar:
        mov     byte ptr ds:[eax],'0'
        dec     eax
        dec     eax
        dec     cl
        jnz     nextchar
        ret
InitScr endp


main    proc c

        mov     [csalias],ds
        call    InitScr

        mov     ax,0204h                      ;save previous IRQ 8 vector
        mov     bl,70h
        int     31h
        mov     dword ptr [oldint70+0],edx
        mov     word ptr [oldint70+4],cx
        mov     ax,0205h                      ;set new IRQ 8 vector 
        mov		ecx, cs
        mov     edx, offset myint70
        int     31h

        cli
        mov     al,0Bh      ;get RTC status
        out     70h,al
        in      al,71h
        mov     bStatus, al
        or      al,40h      ;enable periodic interrupts 
        out     71h, al
        sti
        
        in      al,0A1h
        mov     bMask, al
        and     al,not 1    ;unmask IRQ 8
        out     0A1h,al

        in      al,021h     ;unmask IRQ 2
        and     al,not 4
        out     021h,al
        
main_0:
        mov     ah,0
        int     16h
        cmp     ah,1        ;wait until ESC is pressed
        jnz     main_0
exit:
        cli
        mov     al,0Bh      ;restore the RTC status
        out     70h,al
        mov     al,bStatus
        out     71h, al
        sti
        
        mov     al,bMask    ;restore PIC mask
        out     0A1h,al
        
        mov     ax,0205h    ;restore IRQ 8 vector
        mov     bl,70h
        mov     cx, word ptr [oldint70+4]
        mov     edx, dword ptr [oldint70+0]
        int     31h
        
        mov     ah,4ch
        int     21h
        ret
main    endp

        END main
